;**************************************************************************
;* FileName	: DUMMY200.ASM
;* Date 	: 11.10.2008
;* File version : v1.00
								list l=0
;* Author	: MIKO, Imre
;* Company	:
;* Homepage	: http://majki.atw.hu
;* E-mail	: majki.mester@gmail.com
;*
;*-------------------------------------------------------------------------
;*
;* Description	: Dummy test
;*		  ==================================
;*		  Dummy test code.
;*
;*
;*-------------------------------------------------------------------------
;*
;;* Connections	:	   __________   _________
;*			  |          \_/         |
;*		        ==| n.c	 	GP3/MCLR |== n.c
;*		    +5V	==| Vdd		     Vss |== GND
;*		   n.c.	==| GP2/T0CKI        n.c |== 
;*		   n.c.	==| GP1/ICSPC  ICSPD/GP0 |== n.c.       
;*			  |______________________|
;*			         PIC10F200
;*
;*-------------------------------------------------------------------------
;*
;* Resource	: Ports 	  :    xx /   4 pin   (   %)
;*		  Data memory	  :    xx /  16 byte  (   %)
;*		  Prog memory	  :   xxx / 256 word  (   %)
;*		  Timer0	  : 
;*
;**************************************************************************
;* Revision History:
;*
;* 1.00	  11/01/2008 	Initial Release
;*
;**************************************************************************

	list	p=10f200, r=dec, l=0

;***** INCLUDES ***********************************************************

	include "p10f200.inc"
	include	"..\..\modules\base.inc"


;***** CONFIG *************************************************************

	__CONFIG _IntRC_OSC & _WDT_OFF & _CP_OFF & _MCLRE_OFF 
	__IDLOCS 0100h				; version

	ERRORLEVEL -227				; supress message (Substituting RETLW 0 for RETURN pseudo-op)
	EXPAND_MACROS	EXP_COND		; macro expansion mode
	MULTIPAGE 1, 512, 1			; support for multipage program memory

;***** DEFINES ************************************************************
;#define DEBUG					; for some debug message
;#define NO_DELAY				; for fast simulation
;#define NO_RS232				; for fast simulation
#define PIC_12BIT				; 12 bit device (e.g. 10f20x)

xtal_freq	EQU	4 MHz	  		; crystal frequency
core_freq	EQU	xtal_freq/4		; core operating frequency


; ----- GPIO --------------------------------------------------------------

#define		GPIO_0		GPIO,0		; free
#define		GPIO_1		GPIO,1		; free
#define		GPIO_2		GPIO,2		; free
#define		GPIO_3		GPIO,3		; free (only input or -MCLR!)


;***** MACROS *************************************************************

	include "..\..\modules\dummy.mac"


;***** CONSTANT DEFINITIONS ***********************************************

option_val	EQU	11000010b		; Timer source : intclk / 8
tris_val	EQU	00001111b		; tris value (all input)




;***** VARIABLE DEFINITIONS ***********************************************
	cblock	10h

		TEMP				; dummy register

	endc



;***** ENTRY POINT ********************************************************
		ORG	000h			; processor reset vector
		movwf	OSCCAL
		clrwdt

;----- set configuration --------------------------------------------------
		movlw	tris_val		; set TRIS
		tris	GPIO
		movlw	option_val		; set OPTION
		option

;----- main cycle  --------------------------------------------------------


main_cycle	nop

		; <code>

		goto	main_cycle






;***** sub ****************************************************************
;* 
;* Input :              		; 
;* Output:  				; 
;* Clock :   
;**************************************************************************
sub		return



;***** PAGE INCLUDES ******************************************************

	include "..\..\modules\dummy.inc"

;**************************************************************************

	end					; end of program








