;**************************************************************************
;* FileName	: DUMMY509.ASM
;* Date 	: 25.08.2005
;* File version : v1.00
								list l=0
;* Author	: MIKO, Imre
;* Company	:
;* Homepage	: http://majki.atw.hu
;* E-mail	: majki.mester@gmail.com
;*
;*-------------------------------------------------------------------------
;*
;* Description	: Dummy test
;*		  ==================================
;*		  Dummy test code.
;*
;*
;*-------------------------------------------------------------------------
;*
;;* Connections	:	   __________   _________
;*			  |          \_/         |
;*		    +5V ==| Vdd	 	     Vss |== GND            
;*		   n.c.	==| GP5/OSC1         GP0 |== n.c.              
;*		   n.c.	==| GP4/OSC2         GP1 |== n.c.
;*		   n.c.	==| GP3/-MCLR  GP2/T0CKI |== n.c.       
;*			  |______________________|
;*			         PIC12C509A
;*
;*-------------------------------------------------------------------------
;*
;* Resource	: Ports 	  :    xx /    6 pin   (   %)
;*		  Data memory	  :    xx /   41 byte  (   %)
;*		  Prog memory	  :   xxx / 1024 word  (   %)
;*		  Timer0	  : 
;*
;**************************************************************************
;* Revision History:
;*
;* 1.00	  25/08/2005 	Initial Release
;*
;**************************************************************************

	list	p=12c509a, r=dec, l=0

;***** INCLUDES ***********************************************************

	include "p12c509a.inc"
	include	"..\..\modules\base.inc"


;***** CONFIG *************************************************************

	__CONFIG _IntRC_OSC & _WDT_OFF & _CP_OFF & _MCLRE_OFF 
	__IDLOCS 0100h				; version

	ERRORLEVEL -227				; supress message (Substituting RETLW 0 for RETURN pseudo-op)
	ERRORLEVEL -306				; supress message (Crossing page boundary)
	ERRORLEVEL -307				; supress message (Setting page bits.)
	EXPAND_MACROS	EXP_COND		; macro expansion mode
	MULTIPAGE 2, 512, 2			; support for multipage program memory

;***** DEFINES ************************************************************
;#define DEBUG					; for some debug message
;#define NO_DELAY				; for fast simulation
;#define NO_RS232				; for fast simulation

xtal_freq	EQU	4 MHz	  		; crystal frequency
core_freq	EQU	xtal_freq/4		; core operating frequency


; ----- GPIO --------------------------------------------------------------

#define		GPIO_0		GPIO,0		; free
#define		GPIO_1		GPIO,1		; free
#define		GPIO_2		GPIO,2		; free
#define		GPIO_3		GPIO,3		; free (only input or -MCLR!)
#define		GPIO_4		GPIO,4		; free (or OSC2)
#define		GPIO_5		GPIO,5		; free (or OSC1)


;***** MACROS *************************************************************

	include "..\..\modules\dummy.mac"


;***** CONSTANT DEFINITIONS ***********************************************

option_val	EQU	11000010b		; Timer source : intclk / 8
tris_val	EQU	00111111b		; tris value (all input)




;***** VARIABLE DEFINITIONS ***********************************************
	cblock	07h

		TEMP				; dummy register

	endc



;##########################################################################
;# PAGE 0
;##########################################################################
page_0		ORG	000h			; processor reset vector

;***** ENTRY POINT ********************************************************
		movwf	OSCCAL
		clrwdt
		clrf	GPIO			; clear latch
		goto	start			; jump to real program start


;***** REAL PROGRAM START *************************************************
		org	040h
start		

;----- set configuration --------------------------------------------------
		movlw	tris_val		; set TRIS
		tris	GPIO
		movlw	option_val		; set OPTION
		option

;----- main cycle  --------------------------------------------------------


main_cycle	nop

		; <code>

		pagesel page_0
		call	sub_0

		pagesel page_1
		call	sub_1

		pagesel page_0
		goto	main_cycle






;***** sub_0 **************************************************************
;* 
;* Input :              		; 
;* Output:  				; 
;* Clock :   
;**************************************************************************
sub_0		return



;***** PAGE 0 INCLUDES ****************************************************

	include "..\..\modules\dummy.inc"

;**************************************************************************



;##########################################################################
;# PAGE 1
;##########################################################################
page_1		ORG	0200h


;***** sub_1 **************************************************************
;* 
;* Input :              		; 
;* Output:  				; 
;* Clock :   
;**************************************************************************
sub_1		return



;***** PAGE 1 INCLUDES ****************************************************

	; include "..\..\modules\dummy.inc"

;**************************************************************************
	end					; end of program








